#import "FlutterUpgradePlugin.h"

@implementation FlutterUpgradePlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"flutter_upgrade_plugin"
            binaryMessenger:[registrar messenger]];
    
  FlutterUpgradePlugin* instance = [[FlutterUpgradePlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if([@"getAppVersionName" isEqualToString:call.method]){
      result([self getAppVersion]);
  }else if([@"showUpgradeDialog" isEqualToString:call.method]){
      //最新版本名称
      NSString * serverVersionName = call.arguments[@"serverVersionName"];
      //本地版本名称
      NSString * localVersionName =[self getAppVersion];
      
      if([localVersionName compare:serverVersionName]==kCFCompareLessThan){
        
          NSString * title = call.arguments[@"title"];
          NSString * description = call.arguments[@"description"];
          NSString * appid =call.arguments[@"appid"];
          BOOL force = call.arguments[@"force"];
          
          UIAlertController *alert = [UIAlertController alertControllerWithTitle:title message:description preferredStyle:UIAlertControllerStyleAlert];
          
          if(!force){
              [alert addAction:[UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleDefault handler:nil]];
          }

          [alert addAction:[UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
              [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"https://itunes.apple.com/cn/app/mei-tuan-wai-mai/id%@",appid]]];
          }]];
          
          [[[UIApplication sharedApplication] keyWindow].rootViewController presentViewController:alert animated:YES completion:nil];
      }
  }
  else {
    result(FlutterMethodNotImplemented);
  }
}

-(NSString*)getAppVersion{
    NSDictionary *infoDictionary = [[NSBundle mainBundle] infoDictionary];
    NSString *appVersion = [infoDictionary objectForKey:@"CFBundleShortVersionString"];
    return appVersion;
}


@end
