import 'dart:async';

import 'package:flutter/services.dart';

class FlutterUpgradePlugin {
  static const MethodChannel _channel =
      const MethodChannel('flutter_upgrade_plugin');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  ///获取app版本名称
  static Future<String> get appVersionName async {
    final String appVersionName =
        await _channel.invokeMethod('getAppVersionName');
    return appVersionName;
  }

  ///显示安卓客户端升级更新提示框
  static Future<Null> androidUpgrade({
    String serverVersionName,
    String title,
    String description,
    String apkDownLoadUrl,
    String appid,
    bool force = false,
  }) async {
    await _channel.invokeListMethod("showUpgradeDialog", {
      "serverVersionName": serverVersionName,
      "title": title,
      "description": description,
      "apkDownLoadUrl": apkDownLoadUrl,
      "force": force,
      "appid": appid,
    });
  }
}
